## guile-3.0 3.0.1+1

=== libguile/lightening/tests/Makefile ===
TESTS=$(sort $(basename $(wildcard *.c)))
TARGETS=native ia32 aarch64 armv7

# Suitable values of cross-compiler variables for Debian:
#
#   make test CC_IA32=i668-linux-gnu-gcc CC_AARCH64=aarch64-linux-gnu-gcc
#
# The relevant packages that you need to run this:
#
#   dpkg --add-architecture i386
#   dpkg --add-architecture arm64
#   apt-get update -qq
#   apt-get install -y \
#     libc6-dev:amd64 gcc make \
#     qemu binfmt-support qemu-user-static \
#     gcc-i686-linux-gnu libc6-dev-i386-cross libc6:i386 \
#     gcc-aarch64-linux-gnu libc6-dev-arm64-cross libc6:arm64
#
CC = gcc
CC_IA32=guix environment --pure -s i686-linux --ad-hoc gcc-toolchain glibc -- gcc
CC_AARCH64=guix environment --pure -s aarch64-linux --ad-hoc gcc-toolchain glibc -- gcc
CC_ARMv7=guix environment --pure -s armhf-linux --ad-hoc gcc-toolchain glibc -- gcc
CFLAGS = -Wall -O0 -g

all: $(foreach TARGET,$(TARGETS),$(addprefix test-$(TARGET)-,$(TESTS)))

check: $(addprefix test-$(TARGET),$(TARGETS))

test-%: $(addprefix test-%-,$(TESTS))
	@echo "Running unit tests..."
	@set -e; for test in $?; do \
	  echo "Testing: $$test"; \
	  ./$$test; \
	done
	@echo "Success."

.PHONY: test check

lightening-%.o: ../lightening.h ../lightening/*.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -I.. -o $@ -c ../lightening/lightening.c

test-native-%: %.c lightening-native.o test.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -I.. -o $@ lightening-native.o $<

test-ia32-%: CC = $(CC_IA32)
test-ia32-%: %.c lightening-ia32.o test.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -I.. -o $@ lightening-ia32.o $<

test-aarch64-%: CC = $(CC_AARCH64)
test-aarch64-%: %.c lightening-aarch64.o test.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -I.. -o $@ lightening-aarch64.o $<

test-armv7-%: CC = $(CC_ARMv7)
test-armv7-%: %.c lightening-armv7.o test.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -I.. -o $@ lightening-armv7.o $<

.PRECIOUS: $(foreach TARGET,$(TARGETS),$(addprefix test-$(TARGET)-,$(TESTS)))
.PRECIOUS: $(foreach TARGET,$(TARGETS),lightening-$(TARGET).o)

clean:
	rm -f $(foreach TARGET,$(TARGETS),$(addprefix test-$(TARGET)-,$(TESTS)))
	rm -f $(foreach TARGET,$(TARGETS),lightening-$(TARGET).o)

## guile-3.0 3.0.0+1

=== debian/changelog ===
guile-3.0 (3.0.0+1-1) unstable; urgency=medium

  * Upgrade to 3.0.0.

  * Don't use a fixed /tmp/repl-server path in 00-repl-server.test.  Add
    0007-00-repl-server.test-don-t-use-fixed-path-for-socket.patch to fix
    the problem.

  * Update debian/ for 3.0.

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 26 Jan 2020 12:56:35 -0600

guile-2.2 (2.2.6+1-1) unstable; urgency=medium

  * Upgrade to 2.2.6. (Closes: 935256)

  * Change the /usr/share/slib trigger to interest-noawait.  From Julian
    Andres Klode's bug report:

      slib does not Depend on guile-libs, and I don't think it makes
      sense to add a Depends, so the trigger should be
      interest-noawait. (Triggering packages must Depend on the
      packages they are triggering otherwise ordering can be wrong,
      and installation can break).

      Now, there's also no point to not configure slib until
      guile-libs is triggered. It's enough to use noawait and thus
      only put guile-libs in the triggers-pending state, and it will
      be configured at the end of the apt run.

      Assuming a package wants to use guile with slib in its postinst,
      the package will need to Depend on both of them anyway, and that
      ensures proper ordering.

    Thanks to Julian Andres Klode for reporting the problem and Sebastien
    Bacher for providing the patch that Gianfranco Costamagna had already
    created. (Closes: #903907)

  * Don't fail the build if the after-gc-hook test fails.  Previously this
    was done for mips and mipsel.  Then a potential fix was added
    upstream, but the test has begun failing again on at least amd64, so
    for now, ignore it again.  Add
    0006-gc.test-after-gc-hook-mark-unresolved-on-failure-eve.patch to
    prevent the failure.

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 01 Sep 2019 21:35:20 -0500

guile-2.2 (2.2.4+1-3) unstable; urgency=medium

  * Switch to dh_missing and ignore guile-X.Y for binary-indep.  Thanks to
    Santiago Vila for reporting the problem. (Closes: 930774)

 -- Rob Browning <rlb@defaultvalue.org>  Thu, 27 Jun 2019 00:10:54 -0500

guile-2.2 (2.2.4+1-2) unstable; urgency=medium

  * Backport upstream fix for after-gc-hook test failures.  Replace
    0006-gc.test-after-gc-hook-mark-unresolved-on-failure-for.patch that
    marked the failure as unresolved on mips(el) (a failure which has been
    seen since on at least sparc64 and amd64) with
    0006-Fix-gc.test-after-gc-hook-gets-called-failures.patch which
    addresses the underlying problem. (Closes: 900652)

  * Handle guile-config/guile-snarf/guild as alternatives.  Arrange for
    guile-config, guile-snarf, guild (and guile-tools) to be handled via
    update-alternatives with all of the other tools dependent on
    guile-config.  Configure with "--program-suffix -2.2" which gives the
    binaries the correct names from the start, so that we don't have to
    manually change them in debian/rules.  This also arranges for
    guile-config, etc. to refer to the versioned guile in their #! lines,
    which is what we should have been doing all along.

    Thanks to Ahmed El-Mahmoudy and Norbert Preining for reporting the
    problem, Kari Pahula and Vagrant Cascadian for help devising the fix,
    and Thibaut Paumard for help testing. (Closes: 926182)

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 02 Jun 2019 11:17:15 -0500

guile-2.2 (2.2.4+1-1) unstable; urgency=medium

  * Upgrade to 2.2.4.

 -- Rob Browning <rlb@defaultvalue.org>  Sat, 28 Jul 2018 15:10:51 -0500

guile-2.2 (2.2.3+1-6) unstable; urgency=medium

  * Don't fail the build if the after-gc-hook test fails on mips(el).
    Add 0011-gc.test-after-gc-hook-mark-unresolved-on-failure-for.patch
    to resolve the issue. (Closes: 900652)

 -- Rob Browning <rlb@defaultvalue.org>  Sat, 21 Jul 2018 14:34:22 -0500

guile-2.2 (2.2.3+1-5) unstable; urgency=medium

  * Fix cross-commpilation failures.  Add four upstream patches to fix
    cross-compilation failures on a number of architectures:
      0007-load-thunk-from-memory-reports-the-correct-error.patch
      0008-Fix-error-reporting-in-load-thunk-from-memory.patch
      0009-compile-Load-language-modules-upfront.patch
      0010-elisp-Fix-cross-compilation-support.patch
    Thanks to Helmut Grohne for reporting the problem and helping me to
    reproduce it locally, and to Mark H Weaver for providing the solution.
    (Closes: 900203)

  * Make guile-libs' lintian overrides file arch independent.  Replace
    @MARCH@ with * for now, which is likely fine.  i.e. any file in
    /usr/lib/*guile/...*.go should be a guile compiled code.  Thanks to
    Francois Gouget for reporting the problem. (Closes: 897325)

 -- Rob Browning <rlb@defaultvalue.org>  Sat, 16 Jun 2018 10:30:14 -0500

guile-2.2 (2.2.3+1-4) unstable; urgency=medium

  * i18n.test: accommodate formatting changes in glibc 2.27.  Add
    0006-i18n.test-accommodate-formatting-changes-in-glibc-2..patch to
    look for a non-breaking space (\xa0) rather than an ASCII space as
    the thousands separator for the French locale. (Closes: 896582)

 -- Rob Browning <rlb@defaultvalue.org>  Mon, 21 May 2018 13:56:50 -0500

guile-2.2 (2.2.3+1-3) unstable; urgency=medium

  * Disable more of test-out-of-memory since it's still failing.  It's
    still failing on at least arm64.

 -- Rob Browning <rlb@defaultvalue.org>  Wed, 21 Feb 2018 23:52:49 -0600

guile-2.2 (2.2.3+1-2) unstable; urgency=medium

  * Disable sandbox.test "1e6 alloc loop" "allocation limit" test.  Add
    0003-Disable-sandbox.test-1e6-alloc-loop-allocation-limit.patch to
    disable a test that appears to be causing the test suite to to hang.

  * Disable intermittently failing test-out-of-memory case.  After
    consultation with upstream, add
    0004-Disable-intermittently-failing-test-out-of-memory-te.patch to
    disable a case in test-out-of-memory that was causing a FTBS on some
    architectures.  Thanks to Aaron M. Ucko for reporting the
    problem. (Closes: 880148)



=== debian/control ===
Source: guile-3.0
Section: interpreters
Priority: optional
Maintainer: Rob Browning <rlb@defaultvalue.org>
Build-Depends: libtool, debhelper (>= 9), autoconf, automake, dh-autoreconf,
 guile-3.0:native <cross>,
 libncurses5-dev, libreadline-dev, libltdl-dev, libgmp-dev, texinfo, flex,
 libunistring-dev, libgc-dev, libffi-dev, pkg-config
Standards-Version: 3.7.2
Homepage: http://www.gnu.org/software/guile/

Package: guile-3.0
Section: lisp
Architecture: any
Multi-Arch: allowed
Provides: guile
Depends: guile-3.0-libs (= ${binary:Version}), ${shlibs:Depends},
 ${misc:Depends}
Suggests: guile-3.0-doc
Description: GNU extension language and Scheme interpreter
 Guile is a Scheme implementation designed for real world programming,
 providing a rich Unix interface, a module system, an interpreter, and
 many extension languages.  Guile can be used as a standard #! style
 interpreter, via #!/usr/bin/guile, or as an extension language for
 other applications via libguile.

Package: guile-3.0-dev
Section: lisp
Architecture: any
Provides: libguile-dev
Conflicts: libguile-dev
Depends: ${shlibs:Depends}, guile-3.0:any (= ${binary:Version}),
 guile-3.0-libs (= ${binary:Version}), libc6-dev,
 libncurses5-dev, libreadline6-dev, libltdl-dev, libgmp-dev, libgc-dev,
 pkg-config, ${misc:Depends}
Description: Development files for Guile 3.0
 This package contains files needed for development using Guile 3.0.
 .
 Guile is a Scheme implementation designed for real world programming,
 providing a rich Unix interface, a module system, an interpreter, and
 many extension languages.  Guile can be used as a standard #! style
 interpreter, via #!/usr/bin/guile, or as an extension language for
 other applications via libguile.

Package: guile-3.0-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: dpkg (>= 1.15.4) | install-info, ${misc:Depends}
Description: Documentation for Guile 3.0
 This package contains the Guile documentation, including the Guile
 Reference Manual.
 .
 Guile is a Scheme implementation designed for real world programming,
 providing a rich Unix interface, a module system, an interpreter, and
 many extension languages.  Guile can be used as a standard #! style
 interpreter, via #!/usr/bin/guile, or as an extension language for
 other applications via libguile.

Package: guile-3.0-libs
Section: lisp
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Core Guile libraries
 Guile is a Scheme implementation designed for real world programming,
 providing a rich Unix interface, a module system, an interpreter, and
 many extension languages.  Guile can be used as a standard #! style
 interpreter, via #!/usr/bin/guile, or as an extension language for
 other applications via libguile.

=== debian/rules ===
#!/usr/bin/make -f

# New stable upstream release TODO:
#   s/A.B/C.D/go in debian/control.
#   Adjust debian/changelog.
#   Adjust "ver" variables below.
#   Adjust debian/guile-libs.lintian.
#   Adjust debian/.gitignore.
#   Fix deb_alt_priority below.

SHELL := /bin/bash

pf := set -o pipefail

# Mess to check the exit status of shell commands.  To use it, make sure
# all shell invocations end with $(rc) to print $?, and then pass the
# shell output through shout, which will strip off the exit status if
# it's 0, or crash with diagnostic information if it's not.
chop = $(wordlist 2,$(words $1),x $1)
rc := echo " $$?"
diesh = $(info $(call chop,$(1)))$(info exit: $(lastword $(1)))$(error ($2))
shout = $(if $(lastword $(1)),$(if $(subst 0,,$(lastword $(1))),$(call diesh,$(1),$(2)),$(call chop,$(1))),$(call diesh,$(1),$(2)))

# Make sure the build process doesn't touch the real HOME.
export HOME := $(CURDIR)/debian/no-trespassing

# Keep this in sync with guile-doc.install
expected_info := guile.info $(foreach n,1 2 3 4 5 6 7 8 9 10,guile.info-$(n))

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE := 1

# The version from the changelog (i.e. 2.0.3-1)
deb_src_ver := $(shell dpkg-parsechangelog -S version; $(rc))
deb_src_ver := $(call shout,$(deb_src_ver),dpkg-parsechangelog failed)

# The Debian revision, everything after the last '-' (i.e. the 1 from 2.0.3-1)
deb_src_rev := $(shell $(pf); echo $(deb_src_ver) | sed -e 's/.*-//'; $(rc))
deb_src_rev := $(call shout,$(deb_src_rev),unable to get deb_src_rev)

# Upstream version, everything before the last '-'.
deb_src_ver := $(shell $(pf); echo $(deb_src_ver) | sed -e 's/-[^-]*//'; $(rc))
deb_src_ver := $(call shout,$(deb_src_ver),unable to get deb_src_ver)

deb_src_src_rev := \
  $(shell $(pf); echo $(deb_src_ver) | sed -re 's/.*\+([0-9]+).*/\1/'; $(rc))
deb_src_src_rev := $(call shout,$(deb_src_src_rev),unable to get deb_src_src_rev)

upstream_ver := $(shell $(pf); echo $(deb_src_ver) | sed -e 's/\+.*//'; $(rc))
upstream_ver := $(call shout,$(upstream_ver),unable to get upstream_ver)

# Upstream components
deb_src_maj_ver := $(shell $(pf); echo $(upstream_ver) | cut -d. -f 1; $(rc))
deb_src_min_ver := $(shell $(pf); echo $(upstream_ver) | cut -d. -f 2; $(rc))
deb_src_mic_ver := $(shell $(pf); echo $(upstream_ver) | cut -d. -f 3; $(rc))
deb_src_maj_ver := $(call shout,$(deb_src_maj_ver),unable to get deb_src_maj_ver)
deb_src_min_ver := $(call shout,$(deb_src_min_ver),unable to get deb_src_min_ver)
deb_src_mic_ver := $(call shout,$(deb_src_mic_ver),unable to get deb_src_mic_ver)

deb_src_eff_ver := $(deb_src_maj_ver).$(deb_src_min_ver)
deb_pkg_basename := guile-$(deb_src_eff_ver)
deb_guile_bin_path := /usr/bin/guile-$(deb_src_eff_ver)

ifneq (ok,$(shell x='$(deb_src_min_ver)';  [ "$${\#x}" -lt 4 ] && echo ok;))
  $(error ERROR: alternatives priority expects min version < 1000)
endif

# Up to and including some releases of 2.0.11, this was (incorrectly)
# majminmic (i.e. 2011 for 2.0.11).  As of 3.0, we switched to this,
# i.e. 3.0 -> 3000, 3.1 -> 3001, 3.2 -> 3002, etc.
deb_alt_priority := $(deb_src_maj_ver)$(shell printf "%03d" $(deb_src_min_ver))

multiarch := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH; $(rc))
multiarch := $(call shout,$(multiarch),dpkg-architecture failed)
ifneq ($(multiarch),)
  march = $(multiarch)/
else
  march =
endif

export DEB_CFLAGS_MAINT_APPEND := \
  -DPACKAGE_PACKAGER='"Debian"' \
  -DPACKAGE_PACKAGER_VERSION='"$(upstream_ver)-deb+$(deb_src_src_rev)-$(deb_src_rev)"' \
  -DPACKAGE_PACKAGER_BUG_REPORTS='"http://www.debian.org/Bugs/Reporting"'

# https://debbugs.gnu.org/29464
export DEB_CFLAGS_MAINT_APPEND += -fno-stack-protector

define checkdir
  dh_testdir debian/guile.postinst
endef

%:
	dh $@ --parallel --with autoreconf

.PHONY: check-vars
check-vars:
	@echo "    upstream_ver:" $(upstream_ver)
	@echo "deb_pkg_basename:" $(deb_pkg_basename)
	@echo "     deb_src_ver:" $(deb_src_ver)
	@echo " deb_src_eff_ver:" $(deb_src_eff_ver)
	@echo " deb_src_maj_ver:" $(deb_src_maj_ver)
	@echo " deb_src_min_ver:" $(deb_src_min_ver)
	@echo " deb_src_mic_ver:" $(deb_src_mic_ver)
	@echo " deb_src_src_rev:" $(deb_src_src_rev)
	@echo "     deb_src_rev:" $(deb_src_rev)
	@echo "deb_alt_priority:" $(deb_alt_priority)

# For now, assumes there are no "|" characters in the expansions.
debian/autogen.sed: debian/rules debian/changelog
	echo "s|@UPSTREAM_VER@|$(upstream_ver)|g" > "$@.tmp"
	echo "s|@DEB_SRC_VER@|$(deb_src_ver)|g" >> "$@.tmp"
	echo "s|@DEB_SRC_MAJ_VER@|$(deb_src_maj_ver)|g" >> "$@.tmp"
	echo "s|@DEB_SRC_MIN_VER@|$(deb_src_min_ver)|g" >> "$@.tmp"
	echo "s|@DEB_SRC_MIC_VER@|$(deb_src_mic_ver)|g" >> "$@.tmp"
	echo "s|@DEB_SRC_EFF_VER@|$(deb_src_eff_ver)|g" >> "$@.tmp"
	echo "s|@DEB_PKG_BASENAME@|$(deb_pkg_basename)|g" >> "$@.tmp"
	echo "s|@DEB_ALT_PRIORITY@|$(deb_alt_priority)|g" >> "$@.tmp"
	echo "s|@MARCH@|$(march)|g" >> "$@.tmp"
	mv "$@.tmp" "$@"

autogen_install_files := $(addprefix debian/, \
  guile-$(deb_src_eff_ver).install \
  guile-$(deb_src_eff_ver).links \
  guile-$(deb_src_eff_ver).menu \
  guile-$(deb_src_eff_ver).undocumented \
  guile-$(deb_src_eff_ver)-dev.install \
  guile-$(deb_src_eff_ver)-doc.README.Debian \
  guile-$(deb_src_eff_ver)-doc.install \
  guile-$(deb_src_eff_ver)-libs.install \
  guile-$(deb_src_eff_ver)-libs.lintian-overrides)

autogen_installdeb_files := $(addprefix debian/, \
  guile-$(deb_src_eff_ver).postinst \
  guile-$(deb_src_eff_ver).prerm \
  guile-$(deb_src_eff_ver)-dev.postinst \
  guile-$(deb_src_eff_ver)-dev.prerm \
  guile-$(deb_src_eff_ver)-doc.postinst \
  guile-$(deb_src_eff_ver)-doc.prerm \
  guile-$(deb_src_eff_ver)-libs.postinst \
  guile-$(deb_src_eff_ver)-libs.prerm \
  guile-$(deb_src_eff_ver)-libs.triggers)

debian/guile-$(deb_src_eff_ver).%: debian/guile.% debian/autogen.sed
	sed -f debian/autogen.sed "$<" > "$@.tmp"
	mv "$@.tmp" "$@"
debian/guile-$(deb_src_eff_ver)-dev.%: debian/guile-dev.% debian/autogen.sed
	sed -f debian/autogen.sed "$<" > "$@.tmp"
	mv "$@.tmp" "$@"
debian/guile-$(deb_src_eff_ver)-doc.%: debian/guile-doc.% debian/autogen.sed
	sed -f debian/autogen.sed "$<" > "$@.tmp"
	mv "$@.tmp" "$@"
debian/guile-$(deb_src_eff_ver)-libs.%: debian/guile-libs.% debian/autogen.sed
	sed -f debian/autogen.sed "$<" > "$@.tmp"
	mv "$@.tmp" "$@"

debian/guile-$(deb_src_eff_ver)-doc.postinst:
	DEB_PKG_BASENAME="$(deb_pkg_basename)" \
	DEB_INFO_SUBDIR="$(deb_pkg_basename)" \
	DEB_ALT_PRIORITY="$(deb_alt_priority)" \
	  debian/guile-doc.postinst.gen $(addprefix doc/ref/,$(expected_info)) \
	    > "$@".tmp
	mv "$@.tmp" "$@"

override_dh_testdir:
	$(checkdir)

override_dh_autoreconf:
	echo '$(upstream_ver)' > .version
	cp -a .version .tarball-version
	dh_autoreconf ./autogen.sh

override_dh_auto_configure:
	dh_auto_configure -- --disable-error-on-warning --disable-rpath \
	  --program-suffix "-$(deb_src_eff_ver)"

override_dh_auto_clean:
        # If Makefile doesn't exist GNUmakefile will abort on distclean.
	if test -e Makefile; then make distclean; fi

override_dh_clean:
	-$(MAKE) -C prebuilt clean
	dh_clean $(autogen_install_files) $(autogen_installdeb_files) \
	  .tarball-version \
	  .version \
	  blarg-clean \
	  bootstrap/ice-9/ \
	  bootstrap/language/ \
	  bootstrap/srfi/ \
	  bootstrap/system/ \
	  debian/autogen.sed \
	  doc/r5rs/r5rs.info \
	  doc/ref/autoconf-macros.texi \
	  doc/ref/effective-version.texi \
	  doc/ref/guile.info \
	  doc/ref/guile.info-1 \
	  doc/ref/guile.info-10 \
	  doc/ref/guile.info-2 \
	  doc/ref/guile.info-3 \
	  doc/ref/guile.info-4 \
	  doc/ref/guile.info-5 \
	  doc/ref/guile.info-6 \
	  doc/ref/guile.info-7 \
	  doc/ref/guile.info-8 \
	  doc/ref/guile.info-9 \
	  doc/ref/stamp-vti \
	  doc/ref/version.texi \
	  filesys-test-link.tmp \
	  guile-procedures.txt \
	  libguile/c-tokenize.c \
	  libguile/cpp-E.c \
	  libguile/cpp-SIG.c \
	  libguile/vm-operations.h

# Info pages are installed to /usr/share/info/guile-X.Y/ via
# guile-doc.install, and handled via update-alternatives.

## guile-3.0 3.0.1%2B1

=== debian/changelog ===
guile-3.0 (3.0.1+1-2) unstable; urgency=medium

  * Allow simultaneous installation of newer guile-X.Y-dev packages.
    Handle the one remaining common path /usr/share/aclocal/guile.m4 via
    update-alternatives as guile-autoconf-macros, since the macros it
    includes are explicitly intended to work across versions, and relax
    the package restrictions to allow simultaneous installation of both
    guile-2.2-dev and guile-3.0-dev.

    Have guile-X.Y-dev conflict with guile-1.8 to handle its 1:1.4-24
    libguile-dev conflict.  Apparently we had an epoch and then perhaps
    dropped it when we went to versioned packages (whether we should have
    or not).  In any case, that's old enough that it should be safe to
    ignore it given this accommodation.

    Version the libguile-dev virtual package provision.

 -- Rob Browning <rlb@defaultvalue.org>  Sat, 11 Apr 2020 12:02:28 -0500

guile-3.0 (3.0.1+1-1) unstable; urgency=medium

  * Merge upstream version 3.0.1.

 -- Rob Browning <rlb@defaultvalue.org>  Wed, 18 Mar 2020 19:35:42 -0500

guile-3.0 (3.0.0+1-8) unstable; urgency=medium

  * debian/rules: disable the jit for arm* and x32 again.  The
    make-vtable-vtable patch didn't appear to help.

 -- Rob Browning <rlb@defaultvalue.org>  Mon, 16 Mar 2020 23:58:53 -0500

guile-3.0 (3.0.0+1-7) unstable; urgency=medium

  * Fix incorrect allocation size in make-vtable-vtable.  Add
    0011-Fix-incorrect-allocation-size-in-make-vtable-vtable.patch to
    incorporate the upstream fix.

  * debian/rules: stop setting --enable-jit=no for any architectures.
    Allow the defaults, so we can see if the make-vtable-vtable fix helps.

 -- Rob Browning <rlb@defaultvalue.org>  Mon, 16 Mar 2020 18:31:52 -0500

guile-3.0 (3.0.0+1-6) unstable; urgency=medium

  * debian/rules: set --enable-jit=no on armhf and x32 too.  They're
    demonstrating a similar segfault.

 -- Rob Browning <rlb@defaultvalue.org>  Sat, 14 Mar 2020 10:39:19 -0500

guile-3.0 (3.0.0+1-5) unstable; urgency=medium

  * debian/rules: add build progress watchdog for slower architectures.
    Print "still going" every 10 minutes during the build so that builds
    on mipsel, armel, etc. won't incorrectly time out.  Guile currently
    compiles some of the initial bootstrapping files for a very long time
    with no output.

    Impose a hard 10 hour limit on the build in case it really is stuck,
    which is a bit more than the longest time noticed in the current
    buildd logs.  If necessary, we could rework the whole process to take
    the architecture's expected performance into account.

 -- Rob Browning <rlb@defaultvalue.org>  Fri, 13 Mar 2020 18:21:30 -0500

guile-3.0 (3.0.0+1-4) unstable; urgency=medium

  * debian/rules: correct deb_config_args spelling when disabling jit.

 -- Rob Browning <rlb@defaultvalue.org>  Fri, 13 Mar 2020 00:56:43 -0500

guile-3.0 (3.0.0+1-3) unstable; urgency=medium

  * Disable jit on armel via target arch, not host arch.

 -- Rob Browning <rlb@defaultvalue.org>  Thu, 12 Mar 2020 20:51:52 -0500

guile-3.0 (3.0.0+1-2) unstable; urgency=medium

  * Install libguile-3.0-gdb.scm rather than libguile-2.2-gdb.scm.
    Add 0008-build-Actually-install-libguile-3.0-gdb.scm.patch to fix the
    issue.

  * Update libguile-2.2-gdb.scm to 3.0 in debian/copyright

  * Fix build on platforms where the stack grows upward.  Add
    0009-Fix-build-on-platforms-where-the-stack-grows-upwards.patch to
    incorporate the upstream fix. Thanks to John Paul Adrian Glaubitz for
    the improvement. (Closes: 950635)

  * Fix build on ia64.  Add 0010-Fix-build-on-ia64.patch to incorporate
    the upstream fix.  Thanks to John Paul Adrian Glaubitz for the fix.
    (Closes: 950653)

  * Disable jit on armel until the build segfault is fixed.

 -- Rob Browning <rlb@defaultvalue.org>  Tue, 10 Mar 2020 20:54:35 -0500

## guile-3.0 3.0.1+1

=== debian/rules ===
--- 
+++ 
@@ -27,6 +27,11 @@
 # Keep this in sync with guile-doc.install
 expected_info := guile.info $(foreach n,1 2 3 4 5 6 7 8 9 10,guile.info-$(n))
 
+joblimit := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+ifeq (,$(joblimit))
+  joblimit := 1
+endif
+
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE := 1
 
@@ -76,6 +81,11 @@
   march = $(multiarch)/
 else
   march =
+endif
+
+deb_target_arch := $(shell dpkg-architecture -qDEB_TARGET_ARCH)
+ifneq (,$(filter $(deb_target_arch),armel armhf x32))
+  deb_config_args += --enable-jit=no
 endif
 
 export DEB_CFLAGS_MAINT_APPEND := \
@@ -172,7 +182,17 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- --disable-error-on-warning --disable-rpath \
-	  --program-suffix "-$(deb_src_eff_ver)"
+	  --program-suffix "-$(deb_src_eff_ver)" $(deb_config_args)
+
+# Because some of the bootstrapping files compile for a very long time
+# with no output, the buildds don't have per-package limits, and we
+# don't want to raise the global limit that high for the slower
+# architectures.
+override_dh_auto_build:
+	timeout 10h bash \
+	  -c 'while true; do echo "still going" 1>&2; sleep 600; done' & \
+	trap "kill $$!" EXIT \
+	&& $(MAKE) -j "$(joblimit)"
 
 override_dh_auto_clean:
         # If Makefile doesn't exist GNUmakefile will abort on distclean.
@@ -189,28 +209,3 @@
 	  bootstrap/srfi/ \
 	  bootstrap/system/ \
 	  debian/autogen.sed \
-	  doc/r5rs/r5rs.info \
-	  doc/ref/autoconf-macros.texi \
-	  doc/ref/effective-version.texi \
-	  doc/ref/guile.info \
-	  doc/ref/guile.info-1 \
-	  doc/ref/guile.info-10 \
-	  doc/ref/guile.info-2 \
-	  doc/ref/guile.info-3 \
-	  doc/ref/guile.info-4 \
-	  doc/ref/guile.info-5 \
-	  doc/ref/guile.info-6 \
-	  doc/ref/guile.info-7 \
-	  doc/ref/guile.info-8 \
-	  doc/ref/guile.info-9 \
-	  doc/ref/stamp-vti \
-	  doc/ref/version.texi \
-	  filesys-test-link.tmp \
-	  guile-procedures.txt \
-	  libguile/c-tokenize.c \
-	  libguile/cpp-E.c \
-	  libguile/cpp-SIG.c \
-	  libguile/vm-operations.h
-
-# Info pages are installed to /usr/share/info/guile-X.Y/ via
-# guile-doc.install, and handled via update-alternatives.

## guile-3.0 3.0.2

=== debian/changelog ===
guile-3.0 (3.0.2-2ubuntu1) groovy; urgency=medium

  * Fix build with make 4.3.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 15 Jul 2020 00:10:28 +0200

guile-3.0 (3.0.2-2build1) groovy; urgency=medium

  * No-change rebuild for libgc soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 14 Jul 2020 19:39:19 +0200

guile-3.0 (3.0.2-2) unstable; urgency=medium

  * debian/rules: exclude guile.m4 from arch all package install.

 -- Rob Browning <rlb@defaultvalue.org>  Thu, 16 Apr 2020 18:16:02 -0500

guile-3.0 (3.0.2-1) unstable; urgency=medium

  * Merge upstream version 3.0.2

  * debian/rules: expect an eleventh info page

 -- Rob Browning <rlb@defaultvalue.org>  Mon, 13 Apr 2020 21:29:49 -0500

=== debian/rules ===
--- 
+++ 
@@ -25,7 +25,7 @@
 export HOME := $(CURDIR)/debian/no-trespassing
 
 # Keep this in sync with guile-doc.install
-expected_info := guile.info $(foreach n,1 2 3 4 5 6 7 8 9 10,guile.info-$(n))
+expected_info := guile.info $(foreach n,1 2 3 4 5 6 7 8 9 10 11,guile.info-$(n))
 
 joblimit := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 ifeq (,$(joblimit))
@@ -66,7 +66,7 @@
 deb_pkg_basename := guile-$(deb_src_eff_ver)
 deb_guile_bin_path := /usr/bin/guile-$(deb_src_eff_ver)
 
-ifneq (ok,$(shell x='$(deb_src_min_ver)';  [ "$${\#x}" -lt 4 ] && echo ok;))
+ifneq (ok,$(shell x='$(deb_src_min_ver)';  [ "$${#x}" -lt 4 ] && echo ok;))
   $(error ERROR: alternatives priority expects min version < 1000)
 endif

## guile-3.0 3.0.4

=== debian/changelog ===
guile-3.0 (3.0.4-3~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Sat, 09 Jan 2021 20:33:38 -0500

guile-3.0 (3.0.4-3) unstable; urgency=medium

  * Fix "non-revealed port is closed" ports.test.  Don't close the test
    port's file descriptor because the port still has a reference to it,
    and could still close it at any time when finally garbage collected.
    This was reliably breaking subsequent tests on s390x.  Add
    0007-Fix-non-revealed-port-is-closed-ports.test.patch to fix the
    problem.

 -- Rob Browning <rlb@defaultvalue.org>  Sat, 19 Sep 2020 14:48:42 -0500

guile-3.0 (3.0.4-2) unstable; urgency=medium

  * Mark test-out-of-memory as an expected failure for now.  Since this
    test has been failing for a long time on various architectures, mark
    it as expected to fail for now so that we'll still run it and can see
    the results, but won't be blocked by it.  There are known issues with
    the test upstream, and at least in some past cases it's been possible
    to reproduce the failure quickly by running
    test-suite/standalone/test-out-of-memory in a loop.  Add
    0005-Mark-test-out-of-memory-as-an-expected-failure-for-n.patch to
    incorporate the change. (Closes: 966300)

  * Monitor test failues on ppc64el again (don't ignore dh_auto_test) Now
    that we've marked test-out-of-memory as an expected failure stop
    ignoring dh_auto_test failures on ppc64el. (Closes: 966300, 969707)

  * Disable unresolved "mixed type" numbers.test division tests on i686.
    Add 0006-numbers.test-disable-unresolved-mixed-type-division-.patch to
    incorporate the changes.

  * Monitor test failures on i386 again (don't ignore dh_auto_test) Now
    that we've marked the related numbers.test "mixed types" tests as
    expected failures on i386, stop ignoring dh_auto_test failures there.
    (Closes: 968403)

  * Don't include files generated from examples/Makefile.am in debs.
    Thanks to Vagrant Cascadian for reporting the problem.
    (Closes: 953407)

 -- Rob Browning <rlb@defaultvalue.org>  Wed, 16 Sep 2020 21:00:34 -0500

guile-3.0 (3.0.4-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Also ignore test results on i386, failing numbers.test. See #968403.

 -- Matthias Klose <doko@debian.org>  Fri, 14 Aug 2020 19:58:50 +0200

guile-3.0 (3.0.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Ignore the test results on ppc64el (OOM related failures). See #966300.

 -- Matthias Klose <doko@debian.org>  Fri, 14 Aug 2020 11:37:52 +0200

guile-3.0 (3.0.4-1) unstable; urgency=medium

  * Upgrade to 3.0.4

  * debian/rules: fix deb_src_min_ver limit check.

 -- Rob Browning <rlb@defaultvalue.org>  Tue, 14 Jul 2020 21:39:31 -0500

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: guile-3.0
 Section: interpreters
 Priority: optional
-Maintainer: Rob Browning <rlb@defaultvalue.org>
+Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
+XSBC-Original-Maintainer: Rob Browning <rlb@defaultvalue.org>
 Build-Depends: libtool, debhelper (>= 9), autoconf, automake, dh-autoreconf,
  guile-3.0:native <cross>,
  libncurses5-dev, libreadline-dev, libltdl-dev, libgmp-dev, texinfo, flex,
@@ -27,8 +28,8 @@
 Package: guile-3.0-dev
 Section: lisp
 Architecture: any
-Provides: libguile-dev
-Conflicts: libguile-dev
+Provides: libguile-dev (= ${binary:Version})
+Conflicts: guile-1.8, libguile-dev (<< 2.2.7+1-4), guile-3.0-dev (<< 3.0.1+1-2)
 Depends: ${shlibs:Depends}, guile-3.0:any (= ${binary:Version}),
  guile-3.0-libs (= ${binary:Version}), libc6-dev,
  libncurses5-dev, libreadline6-dev, libltdl-dev, libgmp-dev, libgc-dev,

=== debian/rules ===
--- 
+++ 
@@ -66,7 +66,7 @@
 deb_pkg_basename := guile-$(deb_src_eff_ver)
 deb_guile_bin_path := /usr/bin/guile-$(deb_src_eff_ver)
 
-ifneq (ok,$(shell x='$(deb_src_min_ver)';  [ "$${#x}" -lt 4 ] && echo ok;))
+ifneq (ok,$(shell x='$(deb_src_min_ver)';  [ "$${x}" -lt 1000 ] && echo ok;))
   $(error ERROR: alternatives priority expects min version < 1000)
 endif
 
@@ -102,6 +102,9 @@
 
 %:
 	dh $@ --parallel --with autoreconf
+
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
 
 .PHONY: check-vars
 check-vars:
@@ -207,5 +210,3 @@
 	  bootstrap/ice-9/ \
 	  bootstrap/language/ \
 	  bootstrap/srfi/ \
-	  bootstrap/system/ \
-	  debian/autogen.sed \

## guile-3.0 3.0.5

=== libguile/lightening/tests/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 TESTS=$(sort $(basename $(wildcard *.c)))
-TARGETS=native ia32 aarch64 armv7
+TARGETS ?= native ia32 aarch64 armv7
 
 # Suitable values of cross-compiler variables for Debian:
 #
@@ -17,9 +17,9 @@
 #     gcc-aarch64-linux-gnu libc6-dev-arm64-cross libc6:arm64
 #
 CC = gcc
-CC_IA32=guix environment --pure -s i686-linux --ad-hoc gcc-toolchain glibc -- gcc
-CC_AARCH64=guix environment --pure -s aarch64-linux --ad-hoc gcc-toolchain glibc -- gcc
-CC_ARMv7=guix environment --pure -s armhf-linux --ad-hoc gcc-toolchain glibc -- gcc
+CC_IA32=guix environment --pure -s i686-linux --ad-hoc gcc-toolchain -- gcc
+CC_AARCH64=guix environment --pure -s aarch64-linux --ad-hoc gcc-toolchain -- gcc
+CC_ARMv7=guix environment --pure -s armhf-linux --ad-hoc gcc-toolchain -- gcc
 CFLAGS = -Wall -O0 -g
 
 all: $(foreach TARGET,$(TARGETS),$(addprefix test-$(TARGET)-,$(TESTS)))

=== debian/changelog ===
guile-3.0 (3.0.5-4) unstable; urgency=medium

  * Really don't replace GNU MP malloc/free with libgc's.  The previous
    fix had missed a spot.  Thanks to Andrew Whatson for tracking it
    down. (Closes: 982217)

 -- Rob Browning <rlb@defaultvalue.org>  Thu, 11 Mar 2021 20:04:49 -0600

guile-3.0 (3.0.5-3) unstable; urgency=medium

  * Don't replace GNU MP's malloc/free with the Boehm-Demers-Weiser GC's.
    This can break applications that link against libguile and libgmp.
    Add 0009-Stop-requesting-that-GNU-MP-use-the-Boehm-Demers-Wei.patch to
    address the issue.  Thanks to Andreas Metzler for reporting the
    problem and Ludovic Courtès for proposing the solution.
    (Closes: 982217)

 -- Rob Browning <rlb@defaultvalue.org>  Wed, 10 Mar 2021 18:59:31 -0600

guile-3.0 (3.0.5-2) unstable; urgency=medium

  * Mark asyncs.test "preemption via sigprof" test as unresolved for now.
    Add 0008-Mark-preemption-via-sigprof-test-as-an-expected-fail.patch to
    address the issue.  Thanks to Helmut Grohne for reporting the
    issue. (Closes: 980498)

 -- Rob Browning <rlb@defaultvalue.org>  Thu, 04 Feb 2021 21:20:38 -0600

guile-3.0 (3.0.5-1) unstable; urgency=medium

  * Merge upstream version 3.0.5.

 -- Rob Browning <rlb@defaultvalue.org>  Tue, 12 Jan 2021 19:16:42 -0600

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: guile-3.0
 Section: interpreters
 Priority: optional
-Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
-XSBC-Original-Maintainer: Rob Browning <rlb@defaultvalue.org>
+Maintainer: Rob Browning <rlb@defaultvalue.org>
 Build-Depends: libtool, debhelper (>= 9), autoconf, automake, dh-autoreconf,
  guile-3.0:native <cross>,
  libncurses5-dev, libreadline-dev, libltdl-dev, libgmp-dev, texinfo, flex,

=== debian/rules ===
--- 
+++ 
@@ -102,9 +102,6 @@
 
 %:
 	dh $@ --parallel --with autoreconf
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
 
 .PHONY: check-vars
 check-vars:
@@ -210,3 +207,5 @@
 	  bootstrap/ice-9/ \
 	  bootstrap/language/ \
 	  bootstrap/srfi/ \
+	  bootstrap/system/ \
+	  debian/autogen.sed \

## guile-3.0 3.0.7

=== debian/changelog ===
guile-3.0 (3.0.7-deepin1+rb4) unstable; urgency=medium

  * Rebuild
  * update version
  * Add the debian upstream patch

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 23 Nov 2022 13:16:15 +0800

guile-3.0 (3.0.7-1) unstable; urgency=medium

  * Upgrade to 3.0.7.

  * Fix crash on #nil in syntaxes.  Cherry-pick upstream patch as
    0009-Fix-crash-on-nil-in-syntaxes.patch to address the problem.

  * debian/control: add gperf as a build dependency.  This is now required
    when not building from a release archive, and we build directly from
    the source.

 -- Rob Browning <rlb@defaultvalue.org>  Thu, 26 Aug 2021 16:21:59 -0500

## guile-3.0 3.0.8

=== debian/changelog ===
guile-3.0 (3.0.8-2) unstable; urgency=medium

  * Adjust GUILE_OPTIMIZATIONS to fix 32-bit big endian builds.  Add
    0009-Fix-32-bit-big-endian-builds-via-Oresolve-primitives.patch to
    incorporate the changes.  Thanks to John David Anglin for reporting
    the problem and investigating the problem, and to John Paul Adrian
    Glaubitz for helping devise the solution. (Closes: 977223)

  * Build --without-threads on alpha to fix FTBS.  This will require
    rebuilding all of the reverse dependencies.  Thanks to John Paul
    Adrian Glaubitz for reporting the problem and pursuing the
    solution. (Closes: 995614)

 -- Rob Browning <rlb@defaultvalue.org>  Sat, 05 Mar 2022 16:19:25 -0600

guile-3.0 (3.0.8-1) unstable; urgency=medium

  * Upgrade to 3.0.8.

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 27 Feb 2022 13:52:18 -0600

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
 Priority: optional
 Maintainer: Rob Browning <rlb@defaultvalue.org>
 Build-Depends: libtool, debhelper (>= 9), autoconf, automake, dh-autoreconf,
+ gperf,
  guile-3.0:native <cross>,
  libncurses5-dev, libreadline-dev, libltdl-dev, libgmp-dev, texinfo, flex,
  libunistring-dev, libgc-dev, libffi-dev, pkg-config

=== debian/rules ===
--- 
+++ 
@@ -86,6 +86,9 @@
 deb_target_arch := $(shell dpkg-architecture -qDEB_TARGET_ARCH)
 ifneq (,$(filter $(deb_target_arch),armel armhf x32))
   deb_config_args += --enable-jit=no
+endif
+ifneq (,$(filter $(deb_target_arch),alpha))
+  deb_config_args += --without-threads
 endif
 
 export DEB_CFLAGS_MAINT_APPEND := \
@@ -205,7 +208,3 @@
 	  .version \
 	  blarg-clean \
 	  bootstrap/ice-9/ \
-	  bootstrap/language/ \
-	  bootstrap/srfi/ \
-	  bootstrap/system/ \
-	  debian/autogen.sed \

## guile-3.0 3.0.9

=== debian/changelog ===
guile-3.0 (3.0.9-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 08:55:53 +0000

guile-3.0 (3.0.9-1build1) noble; urgency=medium

  * No-change rebuild for libreadline8t64.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 10 Mar 2024 22:29:06 +0100

guile-3.0 (3.0.9-1) unstable; urgency=medium

  * Upgrade to 3.0.9.

  * debian/copyright: convert to copyright-format 1.0 and expand.

  * debian/rules: switch to buildopts.mk for parallel.

  * debian/.gitignore: add autogen.sed.

  * debian/control: migrate from libncurses5-dev to libncurses-dev.

  * debian/rules: don't ignore make clean errors; let dh_clean handle it.

  * debian/control: migrate from pkg-config to pkgconf.

  * Migrate to debhelper compatibility level 10.

 -- Rob Browning <rlb@defaultvalue.org>  Tue, 13 Feb 2024 15:39:48 -0600

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: guile-3.0
 Section: interpreters
 Priority: optional
-Maintainer: Rob Browning <rlb@defaultvalue.org>
-Build-Depends: libtool, debhelper (>= 9), autoconf, automake, dh-autoreconf,
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Rob Browning <rlb@defaultvalue.org>
+Build-Depends: libtool, debhelper-compat (= 10), autoconf, automake,
  gperf,
  guile-3.0:native <cross>,
- libncurses5-dev, libreadline-dev, libltdl-dev, libgmp-dev, texinfo, flex,
- libunistring-dev, libgc-dev, libffi-dev, pkg-config
+ libncurses-dev, libreadline-dev, libltdl-dev, libgmp-dev, texinfo, flex,
+ libunistring-dev, libgc-dev, libffi-dev, pkgconf
 Standards-Version: 3.7.2
 Homepage: http://www.gnu.org/software/guile/
 
@@ -32,8 +33,8 @@
 Conflicts: guile-1.8, libguile-dev (<< 2.2.7+1-4), guile-3.0-dev (<< 3.0.1+1-2)
 Depends: ${shlibs:Depends}, guile-3.0:any (= ${binary:Version}),
  guile-3.0-libs (= ${binary:Version}), libc6-dev,
- libncurses5-dev, libreadline6-dev, libltdl-dev, libgmp-dev, libgc-dev,
- pkg-config, ${misc:Depends}
+ libncurses-dev, libreadline6-dev, libltdl-dev, libgmp-dev, libgc-dev,
+ pkgconf, ${misc:Depends}
 Description: Development files for Guile 3.0
  This package contains files needed for development using Guile 3.0.
  .

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,8 @@
 #   Adjust debian/guile-libs.lintian.
 #   Adjust debian/.gitignore.
 #   Fix deb_alt_priority below.
+
+include /usr/share/dpkg/buildopts.mk
 
 SHELL := /bin/bash
 
@@ -27,10 +29,7 @@
 # Keep this in sync with guile-doc.install
 expected_info := guile.info $(foreach n,1 2 3 4 5 6 7 8 9 10 11,guile.info-$(n))
 
-joblimit := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-ifeq (,$(joblimit))
-  joblimit := 1
-endif
+joblimit := $(or $(DEB_BUILD_OPTION_PARALLEL),1)
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE := 1
@@ -104,7 +103,7 @@
 endef
 
 %:
-	dh $@ --parallel --with autoreconf
+	dh $@
 
 .PHONY: check-vars
 check-vars:
@@ -154,6 +153,9 @@
   guile-$(deb_src_eff_ver)-libs.prerm \
   guile-$(deb_src_eff_ver)-libs.triggers)
 
+debian/source/lintian-overrides: debian/source-lintian-overrides.in debian/autogen.sed
+	sed -f debian/autogen.sed "$<" > "$@.tmp"
+	mv "$@.tmp" "$@"
 debian/guile-$(deb_src_eff_ver).%: debian/guile.% debian/autogen.sed
 	sed -f debian/autogen.sed "$<" > "$@.tmp"
 	mv "$@.tmp" "$@"
@@ -175,7 +177,7 @@
 	    > "$@".tmp
 	mv "$@.tmp" "$@"
 
-override_dh_testdir:
+override_dh_testdir: debian/source/lintian-overrides
 	$(checkdir)
 
 override_dh_autoreconf:
@@ -202,9 +204,3 @@
 	if test -e Makefile; then make distclean; fi
 
 override_dh_clean:
-	-$(MAKE) -C prebuilt clean
-	dh_clean $(autogen_install_files) $(autogen_installdeb_files) \
-	  .tarball-version \
-	  .version \
-	  blarg-clean \
-	  bootstrap/ice-9/ \

## guile-3.0 3.0.10

=== debian/changelog ===
guile-3.0 (3.0.10-1) unstable; urgency=medium

  * Upgrade to 3.0.10.

  * debian/rules: switch to dpkg pkg-info.mk.

  * debian/rules: switch to dpkg architecture.mk.

  * debian/control: relax libc6-dev dependency to libc-dev.  Thanks to
    Helmut Grohne for the report and the fix. (Closes: 1008712)

  * debian/control: drop install-info dependency.  Thanks to Hilmar
    Preusse for the report. (Closes: 1013197)

 -- Rob Browning <rlb@defaultvalue.org>  Sat, 29 Jun 2024 16:24:59 -0500

=== debian/rules ===
--- 
+++ 
@@ -8,20 +8,11 @@
 #   Adjust debian/.gitignore.
 #   Fix deb_alt_priority below.
 
+include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/buildopts.mk
+include /usr/share/dpkg/pkg-info.mk
 
 SHELL := /bin/bash
-
-pf := set -o pipefail
-
-# Mess to check the exit status of shell commands.  To use it, make sure
-# all shell invocations end with $(rc) to print $?, and then pass the
-# shell output through shout, which will strip off the exit status if
-# it's 0, or crash with diagnostic information if it's not.
-chop = $(wordlist 2,$(words $1),x $1)
-rc := echo " $$?"
-diesh = $(info $(call chop,$(1)))$(info exit: $(lastword $(1)))$(error ($2))
-shout = $(if $(lastword $(1)),$(if $(subst 0,,$(lastword $(1))),$(call diesh,$(1),$(2)),$(call chop,$(1))),$(call diesh,$(1),$(2)))
 
 # Make sure the build process doesn't touch the real HOME.
 export HOME := $(CURDIR)/debian/no-trespassing
@@ -34,32 +25,13 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE := 1
 
-# The version from the changelog (i.e. 2.0.3-1)
-deb_src_ver := $(shell dpkg-parsechangelog -S version; $(rc))
-deb_src_ver := $(call shout,$(deb_src_ver),dpkg-parsechangelog failed)
-
-# The Debian revision, everything after the last '-' (i.e. the 1 from 2.0.3-1)
-deb_src_rev := $(shell $(pf); echo $(deb_src_ver) | sed -e 's/.*-//'; $(rc))
-deb_src_rev := $(call shout,$(deb_src_rev),unable to get deb_src_rev)
-
-# Upstream version, everything before the last '-'.
-deb_src_ver := $(shell $(pf); echo $(deb_src_ver) | sed -e 's/-[^-]*//'; $(rc))
-deb_src_ver := $(call shout,$(deb_src_ver),unable to get deb_src_ver)
-
-deb_src_src_rev := \
-  $(shell $(pf); echo $(deb_src_ver) | sed -re 's/.*\+([0-9]+).*/\1/'; $(rc))
-deb_src_src_rev := $(call shout,$(deb_src_src_rev),unable to get deb_src_src_rev)
-
-upstream_ver := $(shell $(pf); echo $(deb_src_ver) | sed -e 's/\+.*//'; $(rc))
-upstream_ver := $(call shout,$(upstream_ver),unable to get upstream_ver)
-
-# Upstream components
-deb_src_maj_ver := $(shell $(pf); echo $(upstream_ver) | cut -d. -f 1; $(rc))
-deb_src_min_ver := $(shell $(pf); echo $(upstream_ver) | cut -d. -f 2; $(rc))
-deb_src_mic_ver := $(shell $(pf); echo $(upstream_ver) | cut -d. -f 3; $(rc))
-deb_src_maj_ver := $(call shout,$(deb_src_maj_ver),unable to get deb_src_maj_ver)
-deb_src_min_ver := $(call shout,$(deb_src_min_ver),unable to get deb_src_min_ver)
-deb_src_mic_ver := $(call shout,$(deb_src_mic_ver),unable to get deb_src_mic_ver)
+# Upstream version, everything before the last '-', no epoch
+deb_src_ver := $(DEB_VERSION_UPSTREAM)
+
+upstream_ver := $(firstword $(subst +, ,$(deb_src_ver))) # 1.2.3+1 -> 1.2.3
+deb_src_maj_ver := $(word 1,$(subst ., ,$(upstream_ver)))
+deb_src_min_ver := $(word 2,$(subst ., ,$(upstream_ver)))
+deb_src_mic_ver := $(word 3,$(subst ., ,$(upstream_ver)))
 
 deb_src_eff_ver := $(deb_src_maj_ver).$(deb_src_min_ver)
 deb_pkg_basename := guile-$(deb_src_eff_ver)
@@ -74,25 +46,22 @@
 # i.e. 3.0 -> 3000, 3.1 -> 3001, 3.2 -> 3002, etc.
 deb_alt_priority := $(deb_src_maj_ver)$(shell printf "%03d" $(deb_src_min_ver))
 
-multiarch := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH; $(rc))
-multiarch := $(call shout,$(multiarch),dpkg-architecture failed)
-ifneq ($(multiarch),)
-  march = $(multiarch)/
+ifneq ($(DEB_HOST_MULTIARCH),)
+  march = $(DEB_HOST_MULTIARCH)/
 else
   march =
 endif
 
-deb_target_arch := $(shell dpkg-architecture -qDEB_TARGET_ARCH)
-ifneq (,$(filter $(deb_target_arch),armel armhf x32))
+ifneq (,$(filter $(DEB_TARGET_ARCH),armel armhf x32))
   deb_config_args += --enable-jit=no
 endif
-ifneq (,$(filter $(deb_target_arch),alpha))
+ifneq (,$(filter $(DEB_TARGET_ARCH),alpha))
   deb_config_args += --without-threads
 endif
 
 export DEB_CFLAGS_MAINT_APPEND := \
   -DPACKAGE_PACKAGER='"Debian"' \
-  -DPACKAGE_PACKAGER_VERSION='"$(upstream_ver)-deb+$(deb_src_src_rev)-$(deb_src_rev)"' \
+  -DPACKAGE_PACKAGER_VERSION='"$(DEB_VERSION)"' \
   -DPACKAGE_PACKAGER_BUG_REPORTS='"http://www.debian.org/Bugs/Reporting"'
 
 # https://debbugs.gnu.org/29464
@@ -114,8 +83,6 @@
 	@echo " deb_src_maj_ver:" $(deb_src_maj_ver)
 	@echo " deb_src_min_ver:" $(deb_src_min_ver)
 	@echo " deb_src_mic_ver:" $(deb_src_mic_ver)
-	@echo " deb_src_src_rev:" $(deb_src_src_rev)
-	@echo "     deb_src_rev:" $(deb_src_rev)
 	@echo "deb_alt_priority:" $(deb_alt_priority)
 
 # For now, assumes there are no "|" characters in the expansions.
@@ -204,3 +171,60 @@
 	if test -e Makefile; then make distclean; fi
 
 override_dh_clean:
+	dh_clean $(autogen_install_files) $(autogen_installdeb_files) \
+	  .tarball-version \
+	  .version \
+	  blarg-clean \
+	  bootstrap/ice-9/ \
+	  bootstrap/language/ \
+	  bootstrap/srfi/ \
+	  bootstrap/system/ \
+	  debian/autogen.sed \
+	  doc/r5rs/r5rs.info \
+	  doc/ref/autoconf-macros.texi \
+	  doc/ref/effective-version.texi \
+	  doc/ref/guile.info \
+	  doc/ref/guile.info-1 \
+	  doc/ref/guile.info-10 \
+	  doc/ref/guile.info-11 \
+	  doc/ref/guile.info-2 \
+	  doc/ref/guile.info-3 \
+	  doc/ref/guile.info-4 \
+	  doc/ref/guile.info-5 \
+	  doc/ref/guile.info-6 \
+	  doc/ref/guile.info-7 \
+	  doc/ref/guile.info-8 \
+	  doc/ref/guile.info-9 \
+	  doc/ref/stamp-vti \
+	  doc/ref/version.texi \
+	  filesys-test-link.tmp \
+	  guile-procedures.txt \
+	  libguile/c-tokenize.c \
+	  libguile/cpp-E.c \
+	  libguile/cpp-SIG.c \
+	  libguile/vm-operations.h
+
+# Info pages are installed to /usr/share/info/guile-X.Y/ via
+# guile-doc.install, and handled via update-alternatives.
+override_dh_installinfo:
+	true
+
+override_dh_auto_install: $(autogen_install_files)
+	make DESTDIR="$$(pwd)/debian/tmp" INSTALL='install -p' install
+	rm -f debian/tmp/usr/lib/$(march)libguile*.la
+	mkdir -p debian/tmp/usr/share/doc/$(deb_pkg_basename)-dev
+	cp -a examples debian/tmp/usr/share/doc/$(deb_pkg_basename)-dev
+	cd debian/tmp/usr/share/doc/$(deb_pkg_basename)-dev/examples \
+	  && rm Makefile Makefile.in
+
+gdb_ext := \
+  debian/$(deb_pkg_basename)-libs/usr/lib/$(march)libguile-$(deb_src_eff_ver).so*-gdb.scm
+gdb_ext_dir := debian/$(deb_pkg_basename)-dev/usr/share/gdb/auto-load
+
+override_dh_install-arch: $(autogen_install_files)
+	cd debian/tmp/usr/bin && mv -i guile-$(deb_src_eff_ver) guile
+	cd debian/tmp/usr/share/aclocal && mv -i guile.m4 guile-$(deb_src_eff_ver).m4
+	dh_install -a
+	dh_missing -a --fail-missing \
+	  -Xusr/lib/$(march)guile/$(deb_src_eff_ver)/extensions/guile-readline.a \
+	  -Xusr/lib/$(march)guile/$(deb_src_eff_ver)/extensions/guile-readline.la
